## vmpk 0.7.2

=== CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.1)
project(VMPK)

set(DBUS_INIT OFF)
set(ENABLE_CORE OFF)
set(ENABLE_WIN OFF)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(DBUS_INIT ON)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(ENABLE_CORE ON)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set(ENABLE_WIN ON)
endif()

option(ENABLE_DBUS "Enable VMPK DBus interface" ${DBUS_INIT})

# Show full commands and messages.
# set(CMAKE_VERBOSE_MAKEFILE ON CACHE BOOL)

# If relative paths break the link scripts, set it OFF
# set(CMAKE_USE_RELATIVE_PATHS OFF)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_definitions(-DRAWKBD_SUPPORT -DPALETTE_SUPPORT)

# Additional CMake modules for 3rd party library checks reside here
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_admin")

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    if(APPLE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    endif()
else()
    message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

# VMPK version string
set (VERSION_MAJOR "0")
set (VERSION_MINOR "7")
set (VERSION_PATCH "2")
set (VERSION_SUFFIX "")
set (VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX})
add_definitions (-DVERSION=${VERSION})

message (STATUS "VMPK ${VERSION}
    install prefix: ${CMAKE_INSTALL_PREFIX}
     D-Bus support: ${ENABLE_DBUS}")

# User options
message (STATUS "Build configuration: ${CMAKE_BUILD_TYPE}")

# Check for Qt
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5LinguistTools REQUIRED)

if (${ENABLE_DBUS})
    find_package(Qt5DBus REQUIRED)
    add_definitions(-DENABLE_DBUS)
endif ()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")

if (NOT APPLE)
    find_package(PkgConfig REQUIRED)
    if(PKG_CONFIG_FOUND)
        message(STATUS "Program pkg-config found (${PKG_CONFIG_EXECUTABLE})")
    else()
        message(FATAL_ERROR "Program pkg-config not found")
    endif()
endif()

if (UNIX AND NOT APPLE)
    find_package(Qt5X11Extras REQUIRED)
    pkg_check_modules(XCB REQUIRED xcb)
    if(XCB_FOUND)
        include_directories(${XCB_INCLUDE_DIRS})
        link_libraries(${XCB_LIBRARIES})
        link_directories(${XCB_LIB_DIR})
    else()
        message(FATAL_ERROR "Please install XCB development libs and headers.")
    endif()
endif()

if (${ENABLE_CORE})
    link_libraries("-framework CoreFoundation -framework Cocoa")
endif ()

if (${ENABLE_WIN})
    #find_package(WINDRES REQUIRED)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mwindows")
    link_libraries(winmm)
endif ()

if(APPLE)
    find_library(DRUMSTICKRT
        NAMES drumstick-rt
        HINTS $ENV{DRUMSTICK_FRAMEWORKS}
        REQUIRED)
    if(DRUMSTICKRT)
        include_directories(${DRUMSTICKRT}/Headers)
        link_libraries(${DRUMSTICKRT})
    endif()
else()
    pkg_check_modules(DRUMSTICKRT REQUIRED drumstick-rt>=1.1.3)
    if(DRUMSTICKRT_FOUND)
        link_directories(${DRUMSTICKRT_LIBDIR})
        include_directories(${DRUMSTICKRT_INCLUDEDIR})
        link_libraries(${DRUMSTICKRT_LIBRARIES})
    endif()
endif()

add_subdirectory(src)
add_subdirectory(translations)
configure_file(vmpk.spec.in vmpk.spec IMMEDIATE @ONLY)

# uninstall custom target
configure_file(
    "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target( uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set(vmpk_DATA_FILES
    data/gmgsxg.ins
    data/help.html
    data/help_es.html
    data/help_ru.html
    data/help_sr.html
    data/azerty.xml
    data/german.xml
    data/it-qwerty.xml
    data/pc102mac.xml
    data/pc102win.xml
    data/pc102x11.xml
    data/Serbian-cyr.xml
    data/Serbian-lat.xml
    data/spanish.xml
    data/vkeybd-default.xml
    data/txt2ins.awk
)

#unmaintained or deprecated data files:
    #data/hm.html
    #data/hm_es.html
    #data/hm_ru.html
    #data/help_de.html
    #data/help_fr.html
    #data/help_nl.html
    #data/help_ru.html

if(UNIX)
    add_custom_target ( distclean
        COMMAND rm -rf build/*
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
#   add_dependencies (distclean clean)

    add_custom_target (tarball
        COMMAND mkdir -p vmpk-${VERSION}/translations/
        COMMAND cp -r cmake_admin vmpk-${VERSION}
        COMMAND cp -r data vmpk-${VERSION}
        COMMAND cp -r src vmpk-${VERSION}
        COMMAND cp -r man vmpk-${VERSION}
        COMMAND cp -r dbus vmpk-${VERSION}
        COMMAND cp translations/vmpk_{cs,de,es,fr,gl,ru,sr,sv}.ts vmpk-${VERSION}/translations/
        COMMAND cp translations/CMakeLists.txt vmpk-${VERSION}/translations/
        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README *.nsi TODO vmpk.desktop vmpk.pro updateqm.pri vmpk.spec.in qt.conf vmpk-${VERSION}
        COMMAND tar -cj --exclude=.* -f vmpk-${VERSION}.tar.bz2 vmpk-${VERSION}
        COMMAND tar -cz --exclude=.* -f vmpk-${VERSION}.tar.gz vmpk-${VERSION}
        COMMAND rm -rf vmpk-${VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
endif ()

if(UNIX AND NOT APPLE)

    add_subdirectory (man)

    install (FILES ${vmpk_DATA_FILES}
             DESTINATION share/vmpk )

    install (FILES data/vmpk_16x16.png
             DESTINATION share/icons/hicolor/16x16/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_32x32.png
             DESTINATION share/icons/hicolor/32x32/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_48x48.png
             DESTINATION share/icons/hicolor/48x48/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_64x64.png
             DESTINATION share/icons/hicolor/64x64/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_128x128.png
             DESTINATION share/icons/hicolor/128x128/apps
             RENAME vmpk.png)

    install (FILES data/vmpk.svgz
             DESTINATION share/icons/hicolor/scalable/apps )

    install (FILES vmpk.desktop
             DESTINATION share/applications )

endif ()

if(WIN32)
    include (InstallRequiredSystemLibraries)
	install (FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} 
			 DESTINATION .)
    install (FILES ${vmpk_DATA_FILES}
             DESTINATION .)
endif()

#if(APPLE)
#    set (target "vmpk")
#    configure_file ("${CMAKE_SOURCE_DIR}/cmake_admin/CompleteBundle.cmake.in"
#      "${CMAKE_CURRENT_BINARY_DIR}/build/CompleteBundle.cmake" @ONLY IMMEDIATE)
#    configure_file ("${CMAKE_SOURCE_DIR}/cmake_admin/CreateBundle.sh.in"
#      "${CMAKE_CURRENT_BINARY_DIR}/build/CreateBundle.sh" @ONLY IMMEDIATE)
#    install (SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/build/CompleteBundle.cmake")
#endif ()

# CPack support
include (InstallRequiredSystemLibraries)
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Virtual MIDI Piano Keyboard")
set (CPACK_PACKAGE_VENDOR "vmpk.sourceforge.net")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/gpl.rtf")
set (CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set (CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set (CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set (CPACK_PACKAGE_INSTALL_DIRECTORY "vmpk")
set (CPACK_PACKAGE_EXECUTABLES "vmpk" "Virtual MIDI Piano Keyboard")

# source packages
set (CPACK_SOURCE_GENERATOR TGZ;TBZ2;ZIP)
set (CPACK_SOURCE_IGNORE_FILES "/.svn/;/build/;/share/;~$;.cproject;.project;.user;${CPACK_SOURCE_IGNORE_FILES}")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "vmpk-${VERSION}")
set (CPACK_SOURCE_STRIP_FILES OFF)

# linux binary packages
if (${CMAKE_SYSTEM} MATCHES "Linux")
    set (CPACK_GENERATOR TGZ;TBZ2)
    set (CPACK_PACKAGE_NAME "vmpk")
    math (EXPR PWORD_SIZE "${CMAKE_SIZEOF_VOID_P}*8")
    set (CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}-x86_${PWORD_SIZE})
#   set (CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)
#   set (CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
    set (CPACK_STRIP_FILES ON)
endif ()

# Windows NSIS setup package
#if (WIN32)
#    set (CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/src/vmpk.ico")
#    set (CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\MyExecutable.exe")
#    set (CPACK_NSIS_DISPLAY_NAME "Virtual MIDI Piano Keyboard")
#    set (CPACK_NSIS_HELP_LINK "http://vmpk.sourceforge.net")
#    set (CPACK_NSIS_URL_INFO_ABOUT "http://vmpk.sourceforge.net")
#    set (CPACK_NSIS_CONTACT "plcl@users.sourceforge.net")
#    set (CPACK_NSIS_MODIFY_PATH OFF)
#endif ()

# Mac OSX bundle
#if (APPLE)
#endif ()

include (CPack)

=== man/CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

FIND_PROGRAM(XSLTPROC_EXECUTABLE xsltproc)
IF(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    INCLUDE(CreateManpages)
    CREATE_MANPAGES(vmpk.xml)
ELSE(XSLTPROC_EXECUTABLE)
    MESSAGE(STATUS "XSLTPROC NOT Found")
    INSTALL( FILES vmpk.1 DESTINATION share/man/man1 )
ENDIF(XSLTPROC_EXECUTABLE)

=== src/CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2019 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR})

set(vmpk_forms_SRCS
    about.ui
    colordialog.ui
    extracontrols.ui
    kmapdialog.ui
    midisetup.ui
    preferences.ui
    riffimportdlg.ui
    vpiano.ui
    shortcutdialog.ui
    fluidsettingsdialog.ui
    networksettingsdialog.ui
    macsynthsettingsdialog.ui
    sonivoxsettingsdialog.ui
)

QT5_WRAP_UI(vmpk_ui_SRCS ${vmpk_forms_SRCS})

set(vmpk_SRCS
    about.cpp
    about.h
    colordialog.cpp
    colordialog.h
    colorwidget.cpp
    colorwidget.h
    constants.h
    extracontrols.cpp
    extracontrols.h
    instrument.cpp
    instrument.h
    keyboardmap.cpp
    keyboardmap.h
    keylabel.cpp
    keylabel.h
    kmapdialog.cpp
    kmapdialog.h
    main.cpp
    mididefs.h
    midisetup.cpp
    midisetup.h
    pianodefs.h
    pianokeybd.cpp
    pianokeybd.h
    pianokey.cpp
    pianokey.h
    pianopalette.cpp
    pianopalette.h
    pianoscene.cpp
    pianoscene.h
    preferences.cpp
    preferences.h
    nativefilter.cpp
    nativefilter.h
    riff.cpp
    riff.h
    riffimportdlg.cpp
    riffimportdlg.h
    shortcutdialog.cpp
    shortcutdialog.h
    fluidsettingsdialog.cpp
    fluidsettingsdialog.h
    networksettingsdialog.cpp
    networksettingsdialog.h
    macsynthsettingsdialog.cpp
    macsynthsettingsdialog.h
    sonivoxsettingsdialog.cpp
    sonivoxsettingsdialog.h
    vpiano.cpp
    vpiano.h )

QT5_ADD_RESOURCES(vmpk_SRCS ../data/vmpk.qrc)

set(vmpk_qtobject_SRCS
    about.h
    colordialog.h
    colorwidget.h
    extracontrols.h
    kmapdialog.h
    midisetup.h
    pianokeybd.h
    pianoscene.h
    preferences.h
    riff.h
    riffimportdlg.h
    vpiano.h
    fluidsettingsdialog.h
    networksettingsdialog.h
    macsynthsettingsdialog.h
    sonivoxsettingsdialog.h
    shortcutdialog.h)

if(ENABLE_DBUS)
    QT5_ADD_DBUS_ADAPTOR (vmpk_SRCS
                          net.sourceforge.vmpk.xml 
                          vpiano.h 
                          VPiano
                          vmpk_adaptor)
endif()

QT5_WRAP_CPP(vmpk_moc_SRCS ${vmpk_qtobject_SRCS})

if(UNIX AND NOT APPLE)
    add_executable (vmpk
                    ${vmpk_ui_SRCS}
                    ${vmpk_moc_SRCS}
                    ${vmpk_SRCS})
    install (TARGETS vmpk
             RUNTIME DESTINATION bin)
endif()

if(WIN32)
    set (vmpk_RESOURCES)
    configure_file (vmpk.rc.in ${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc 
                    IMMEDIATE @ONLY)
	set (vmpk_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc)
    add_executable (vmpk WIN32
                    ${vmpk_ui_SRCS}
                    ${vmpk_moc_SRCS}
                    ${vmpk_SRCS}
                    ${vmpk_RESOURCES})
    install (TARGETS vmpk
			 RUNTIME DESTINATION .)
endif()

if(APPLE)
    set(vmpk_SRCS ${vmpk_SRCS} maceventhelper.mm)
    #set (MACOSX_BUNDLE_INFO_STRING "Virtual MIDI Piano Keyboard" )
    set (MACOSX_BUNDLE_BUNDLE_VERSION ${VERSION} )
    set (MACOSX_BUNDLE_LONG_VERSION_STRING ${VERSION})
    set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${VERSION})
    set (MACOSX_BUNDLE_ICON_FILE "vmpk.icns" )
    set (MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge" )
    set (MACOSX_BUNDLE_BUNDLE_NAME "vmpk" )
    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2018 Pedro López-Cabanillas and others")
    set (vmpk_RSC ../data/vmpk.icns
             ../data/help.html
             ../data/help_es.html
             ../data/txt2ins.awk
             ../data/gmgsxg.ins
             ../data/spanish.xml
             ../data/german.xml
             ../data/azerty.xml
             ../data/it-qwerty.xml
             ../data/vkeybd-default.xml
             ../data/pc102mac.xml )
    set_source_files_properties (${vmpk_RSC} PROPERTIES
                                 MACOSX_PACKAGE_LOCATION Resources)
    add_executable (vmpk MACOSX_BUNDLE
        ${vmpk_ui_SRCS}
        ${vmpk_moc_SRCS}
        ${vmpk_SRCS}
        ${vmpk_RSC}
    )
    set_target_properties(vmpk PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/data/Info.plist.in)
    target_link_libraries(vmpk
        "-framework Cocoa"
    )
endif()

target_link_libraries(vmpk
    Qt5::Widgets
    Qt5::Svg
    Qt5::Network
)

if(ENABLE_DBUS)
    target_link_libraries(vmpk
        Qt5::DBus
    )
endif()

if(UNIX AND NOT APPLE)
    target_link_libraries(vmpk
        Qt5::X11Extras
    )
endif()

=== translations/CMakeLists.txt ===
# unmaintained translations, not installed
#    vmpk_nl.ts
#    vmpk_tr.ts
#    vmpk_zh_CN.ts

SET( TRANSLATIONS_FILES
     vmpk_cs.ts
     vmpk_de.ts
     vmpk_es.ts
     vmpk_fr.ts
     vmpk_gl.ts
     vmpk_ru.ts
     vmpk_sr.ts
     vmpk_sv.ts
)

QT5_ADD_TRANSLATION(QM_FILES ${TRANSLATIONS_FILES})
ADD_CUSTOM_TARGET(translations ALL DEPENDS ${QM_FILES})

IF (UNIX AND NOT APPLE)
    INSTALL( FILES ${QM_FILES}
             DESTINATION share/vmpk/locale )
ELSE (UNIX AND NOT APPLE)
    INSTALL( FILES ${QM_FILES}
             DESTINATION . )
ENDIF (UNIX AND NOT APPLE)

=== debian/changelog ===
vmpk (0.7.2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:28:24 +0100

vmpk (0.7.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Bump libdrumstick-dev to 1.1.3.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 05 Sep 2019 21:20:19 +0200

vmpk (0.7.1-1) unstable; urgency=medium

  * Team upload.

  [ Ross Gammon ]
  * New upstream release
  * New maintainer (Closes: #797535)
  * Embedded copy of RiMidi no longer included (Closes: #758046)
  * Update to QT5 dependencies (Closes: #870355, #875238)
  * Unapply patches from source
  * Build depend on latest libdrumstick for new RT library
  * Add myself as uploaders
  * Use latest secure & canonical Vcs URIs
  * Drop old build options & add bindnow hardening option
  * Update copyrights & move to copyright format 1.0
  * Switch to Debian Multimedia Team maintenance

  [ Sebastian Ramacher ]
  * debian/control:
    - Bump debhelper compat to 12.
    - Set Priority to optional.
    - Bump Standards-Version.
  * debian/rules: Force cmake build system.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 23 Aug 2019 21:34:23 +0200

=== debian/control ===
Source: vmpk
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Ross Gammon <rosco2@ubuntu.com>
Build-Depends: debhelper-compat (= 12),
 cmake,
 pkg-config,
 xsltproc,
 docbook-xsl,
 docbook-xml,
 libasound2-dev,
 libx11-dev,
 qtbase5-dev,
 libqt5svg5-dev,
 qttools5-dev-tools,
 qttools5-dev,
 libqt5x11extras5-dev,
 libdrumstick-dev (>= 1.1.3)
Standards-Version: 4.4.0
Homepage: http://vmpk.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/multimedia-team/vmpk
Vcs-Git: https://salsa.debian.org/multimedia-team/vmpk.git

Package: vmpk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: qjackctl, qsynth
Description: Virtual MIDI Piano Keyboard
 Virtual MIDI Piano Keyboard is a MIDI events generator and
 receiver. It doesn't produce any sound by itself, but can be used to
 drive a MIDI synthesizer (either hardware or software, internal or
 external). You can use the computer's keyboard to play MIDI notes,
 and also the mouse. You can use the Virtual MIDI Piano Keyboard to
 display the played MIDI notes from another instrument or MIDI file
 player.

## vmpk 0.8.6

=== CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.14)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")

project( VMPK
    VERSION 0.8.6
    LANGUAGES CXX
    DESCRIPTION "Virtual MIDI Piano Keyboard"
    HOMEPAGE_URL "https://vmpk.sourceforge.io/"
)

set(DBUS_INIT OFF)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(DBUS_INIT ON)
endif()
option(ENABLE_DBUS "Enable VMPK DBus interface" ${DBUS_INIT})
option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)
option(BUILD_DOCS "Build man page" ON)
option(USE_QT "Choose which Qt major version (5 or 6) to prefer. By default uses whatever is found")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_admin")
include(SCMRevision)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# cmake bug https://gitlab.kitware.com/cmake/cmake/issues/18396 closed in cmake 3.14
if(APPLE AND ${CMAKE_VERSION} VERSION_LESS 3.14)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra") #-Wzero-as-null-pointer-constant -Wsuggest-override
endif()
#if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Wall")
#endif()

# CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2021/03
if(MSVC)
    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
endif()

if (USE_QT)
    if (NOT (USE_QT EQUAL 5 OR USE_QT EQUAL 6))
        message(FATAL_ERROR "Wrong Qt major version. Only 5 and 6 are valid options")
    endif()
endif()

if (USE_QT EQUAL 5)
    find_package(QT NAMES Qt5)
elseif (USE_QT EQUAL 6)
    find_package(QT NAMES Qt6)
else()
    find_package(QT NAMES Qt5 Qt6)
endif()

if (QT_VERSION VERSION_LESS 6.0)
    find_package(Qt5 5.9 COMPONENTS Widgets Network LinguistTools REQUIRED)
else()
    if (QT_VERSION VERSION_LESS 6.2.0)
       message (FATAL_ERROR "Qt6 >= 6.2 is required, or use Qt5 >= 5.9")
    endif()
    find_package(Qt6 6.2 COMPONENTS Gui Widgets Network LinguistTools REQUIRED)
endif()

find_package(Drumstick 2.5 COMPONENTS RT Widgets REQUIRED)

message (STATUS "VMPK v${PROJECT_VERSION}
     install prefix: ${CMAKE_INSTALL_PREFIX}
     Build configuration: ${CMAKE_BUILD_TYPE}
     Operating System: ${CMAKE_SYSTEM_NAME}
     System Processor: ${CMAKE_SYSTEM_PROCESSOR}
     D-Bus support: ${ENABLE_DBUS}
     Qt${QT_VERSION_MAJOR} Version: ${QT_VERSION}
     Drumstick Version: ${Drumstick_VERSION}"
)

if (ENABLE_DBUS)
    find_package(Qt${QT_VERSION_MAJOR}DBus REQUIRED)
endif ()

if (UNIX AND NOT APPLE)
    if (QT_VERSION VERSION_LESS 6.0.0)
        find_package(Qt5X11Extras REQUIRED)
    endif()
    find_package(PkgConfig REQUIRED)
    if(PKG_CONFIG_FOUND)
        message(STATUS "Program pkg-config v${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
    else()
        message(FATAL_ERROR "Program pkg-config not found")
    endif()
    pkg_check_modules(XCB REQUIRED xcb)
    if(XCB_FOUND)
        message(STATUS "Found XCB development libs v${XCB_VERSION}")
    endif()
    include(GNUInstallDirs)
endif()

add_subdirectory(src)
if (NOT EMBED_TRANSLATIONS)
    add_subdirectory(translations)
endif()

set(vmpk_DATA_FILES
    data/gmgsxg.ins
    data/help.html
    data/help_es.html
    data/help_ru.html
    data/help_sr.html
    data/azerty.xml
    data/german.xml
    data/it-qwerty.xml
    data/pc102mac.xml
    data/pc102win.xml
    data/pc102x11.xml
    data/Serbian-cyr.xml
    data/Serbian-lat.xml
    data/spanish.xml
    data/vkeybd-default.xml
    data/txt2ins.awk
)

#unmaintained or deprecated data files:
    #data/hm.html
    #data/hm_es.html
    #data/hm_ru.html
    #data/help_de.html
    #data/help_fr.html
    #data/help_nl.html

if(UNIX)
    add_custom_target (tarball
        COMMAND mkdir -p vmpk-${PROJECT_VERSION}/translations/
        COMMAND cp -r cmake_admin vmpk-${PROJECT_VERSION}
        COMMAND cp -r data vmpk-${PROJECT_VERSION}
        COMMAND cp -r src vmpk-${PROJECT_VERSION}
        COMMAND cp -r man vmpk-${PROJECT_VERSION}
        COMMAND cp -r dbus vmpk-${PROJECT_VERSION}
        COMMAND cp translations/vmpk_{cs,de,es,fr,gl,ru,sr,sv}.ts vmpk-${PROJECT_VERSION}/translations/
        COMMAND cp translations/CMakeLists.txt vmpk-${PROJECT_VERSION}/translations/
        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README.md TODO *.nsi *.nsi.in net.sourceforge.VMPK.desktop net.sourceforge.VMPK.appdata.xml vmpk.pro *.pri vmpk.spec.in qt.conf vmpk-${PROJECT_VERSION}
        COMMAND tar -cj --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.bz2 vmpk-${PROJECT_VERSION}
        COMMAND tar -cz --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.gz vmpk-${PROJECT_VERSION}
        COMMAND zip -qr vmpk-${PROJECT_VERSION}.zip vmpk-${PROJECT_VERSION} -x '.[a-z]*'
        COMMAND rm -rf vmpk-${PROJECT_VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
endif ()

if(UNIX AND NOT APPLE)
    configure_file ( vmpk.spec.in
        ${CMAKE_CURRENT_BINARY_DIR}/vmpk.spec
        IMMEDIATE @ONLY )
    add_subdirectory (man)

    install (FILES ${vmpk_DATA_FILES}
             DESTINATION ${CMAKE_INSTALL_DATADIR}/vmpk )

    install (FILES data/vmpk_16x16.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_32x32.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_48x48.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_64x64.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_128x128.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps
             RENAME vmpk.png)

    install (FILES data/vmpk.svgz
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps )

    install (FILES net.sourceforge.VMPK.desktop
             DESTINATION ${CMAKE_INSTALL_DATADIR}/applications )

    install (FILES net.sourceforge.VMPK.appdata.xml
             DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo )

     # uninstall custom target
     configure_file(
         "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
         "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
         IMMEDIATE @ONLY)
     add_custom_target( uninstall
         "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif ()

if(WIN32)
    include (InstallRequiredSystemLibraries)
	install (FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} 
			 DESTINATION .)
    install (FILES ${vmpk_DATA_FILES}
             DESTINATION .)
	set(FLUIDSYNTH_PREFIX $ENV{FLUIDSYNTH})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup-msvc2019.nsi.in
        ${CMAKE_CURRENT_BINARY_DIR}/setup-msvc2019.nsi IMMEDIATE @ONLY)
endif()

# CPack support
include (InstallRequiredSystemLibraries)
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Virtual MIDI Piano Keyboard")
set (CPACK_PACKAGE_VENDOR "vmpk.sourceforge.net")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/gpl.rtf")
set (CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_PROJECT_VERSION_MAJOR})
set (CPACK_PACKAGE_VERSION_MINOR ${CMAKE_PROJECT_VERSION_MINOR})
set (CPACK_PACKAGE_VERSION_PATCH ${CMAKE_PROJECT_VERSION_PATCH})
set (CPACK_PACKAGE_INSTALL_DIRECTORY "vmpk")
set (CPACK_PACKAGE_EXECUTABLES "vmpk" "Virtual MIDI Piano Keyboard")

# source packages
set (CPACK_SOURCE_GENERATOR TGZ;TBZ2;ZIP)
set (CPACK_SOURCE_IGNORE_FILES "/.svn/;/build/;/share/;~$;.cproject;.project;.user;${CPACK_SOURCE_IGNORE_FILES}")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "vmpk-${PROJECT_VERSION}")
set (CPACK_SOURCE_STRIP_FILES OFF)

# linux binary packages
if (${CMAKE_SYSTEM} MATCHES "Linux")
    set (CPACK_GENERATOR TGZ;TBZ2)
    set (CPACK_PACKAGE_NAME "vmpk")
    set (CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR})
#   set (CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)
#   set (CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
    set (CPACK_STRIP_FILES ON)
endif ()

# Windows NSIS setup package
#if (WIN32)
#    set (CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/src/vmpk.ico")
#    set (CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\MyExecutable.exe")
#    set (CPACK_NSIS_DISPLAY_NAME "Virtual MIDI Piano Keyboard")
#    set (CPACK_NSIS_HELP_LINK "http://vmpk.sourceforge.net")
#    set (CPACK_NSIS_URL_INFO_ABOUT "http://vmpk.sourceforge.net")
#    set (CPACK_NSIS_CONTACT "plcl@users.sourceforge.net")
#    set (CPACK_NSIS_MODIFY_PATH OFF)
#endif ()

include (CPack)

=== man/CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

if (BUILD_DOCS)
    find_program(XSLTPROC_EXECUTABLE xsltproc)
endif()

if (XSLTPROC_EXECUTABLE)
    message(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    include(CreateManpages)
    create_manpages(vmpk.xml)
else()
    install( FILES vmpk.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 )
endif()

=== src/CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (EMBED_TRANSLATIONS)
    set( TRANSLATIONS
         ../translations/vmpk_cs.ts
         ../translations/vmpk_de.ts
         ../translations/vmpk_es.ts
         ../translations/vmpk_fr.ts
         ../translations/vmpk_gl.ts
         ../translations/vmpk_ru.ts
         ../translations/vmpk_sr.ts
         ../translations/vmpk_sv.ts
    )
    if (QT_VERSION VERSION_LESS 5.15.0)
        qt5_add_translation(QM_FILES ${TRANSLATIONS})
    else()
        qt_add_translation(QM_FILES ${TRANSLATIONS})
    endif()
    include(TranslationUtils)
    get_target_property(DRUMSTICK_LOCATION Drumstick::Widgets INTERFACE_INCLUDE_DIRECTORIES)
    get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_LOCATION} DIRECTORY)
    file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
    file(COPY ${WIDGETS_TRANS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    add_app_translations_resource(APP_RES ${QM_FILES} ${WIDGETS_TRANS})
    add_qt_translations_resource(QT_RES cs de es fr gl ru sr sv)
endif()

set(vmpk_SRCS
    about.ui
    colordialog.ui
    extracontrols.ui
    kmapdialog.ui
    midisetup.ui
    preferences.ui
    riffimportdlg.ui
    vpiano.ui
    shortcutdialog.ui
    about.cpp
    about.h
    colordialog.cpp
    colordialog.h
    colorwidget.cpp
    colorwidget.h
    constants.h
    extracontrols.cpp
    extracontrols.h
    instrument.cpp
    instrument.h
    keyboardmap.cpp
    keyboardmap.h
    kmapdialog.cpp
    kmapdialog.h
    maceventhelper.h
    main.cpp
    mididefs.h
    midisetup.cpp
    midisetup.h
    preferences.cpp
    preferences.h
    nativefilter.cpp
    nativefilter.h
    riff.cpp
    riff.h
    riffimportdlg.cpp
    riffimportdlg.h
    shortcutdialog.cpp
    shortcutdialog.h
    vpiano.cpp
    vpiano.h
    vpianosettings.cpp
    vpianosettings.h
    ../data/vmpk.qrc
    ${APP_RES}
    ${QT_RES}
)

if(WIN32)
    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("#include <Windows.h>
        int main() { EnumWindows([](HWND, LPARAM) -> BOOL { return true; }, 0); return 0; }"
        COMPILER_SUPPORTED)
    if (NOT COMPILER_SUPPORTED)
        message(FATAL_ERROR "Sorry, your compiler is not supported: ${CMAKE_CXX_COMPILER}")
    endif()
    list(APPEND vmpk_SRCS winsnap.cpp winsnap.h)
endif()

if(ENABLE_DBUS)
    add_definitions(-DENABLE_DBUS)
    if (QT_VERSION VERSION_LESS 5.15.0)
        qt5_add_dbus_adaptor( vmpk_SRCS
                              net.sourceforge.vmpk.xml
                              vpiano.h
                              VPiano
                              vmpk_adaptor )
    else()
        qt_add_dbus_adaptor( vmpk_SRCS
                             net.sourceforge.vmpk.xml
                             vpiano.h
                             VPiano
                             vmpk_adaptor )
    endif()
    set_property(SOURCE
        ${CMAKE_CURRENT_BINARY_DIR}/vmpk_adaptor.h
        ${CMAKE_CURRENT_BINARY_DIR}/vmpk_adaptor.cpp
        PROPERTY SKIP_AUTOGEN ON)
endif()

if(WIN32)
    configure_file (vmpk.rc.in ${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc 
                    IMMEDIATE @ONLY)
endif()

if(APPLE)
    set (MACOSX_BUNDLE_INFO_STRING "Virtual MIDI Piano Keyboard" )
    set (MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION} )
    set (MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION} )
    set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION} )
    set (MACOSX_BUNDLE_ICON_FILE "vmpk.icns" )
    set (MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.vmpk" )
    set (MACOSX_BUNDLE_BUNDLE_NAME "vmpk" )
    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2021 Pedro López-Cabanillas and others")
    set (vmpk_RSC
        ../data/vmpk.icns
        ../data/help.html
        ../data/help_es.html
        ../data/txt2ins.awk
        ../data/gmgsxg.ins
        ../data/spanish.xml
        ../data/german.xml
        ../data/azerty.xml
        ../data/it-qwerty.xml
        ../data/vkeybd-default.xml
        ../data/pc102mac.xml
    )
    set_source_files_properties (${vmpk_RSC} PROPERTIES
        MACOSX_PACKAGE_LOCATION Resources
    )
endif()

add_executable (vmpk MACOSX_BUNDLE WIN32
    $<$<PLATFORM_ID:Darwin>:maceventhelper.mm>
    $<$<PLATFORM_ID:Windows>:${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc>
    ${vmpk_SRCS}
    ${vmpk_RSC}
)

target_link_libraries(vmpk PRIVATE
    Drumstick::RT
    Drumstick::Widgets
    Qt${QT_VERSION_MAJOR}::Widgets
    $<$<BOOL:${ENABLE_DBUS}>:Qt${QT_VERSION_MAJOR}::DBus>
    $<$<BOOL:${Qt5X11Extras_FOUND}>:Qt5::X11Extras>
    $<$<BOOL:${XCB_FOUND}>:${XCB_LIBRARIES}>
)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries(vmpk PRIVATE Qt6::Gui)
endif()

if (WIN32)
    target_link_libraries(vmpk PRIVATE
        winmm
        dwmapi)
endif()

if (APPLE)
    target_link_libraries(vmpk PRIVATE "-framework CoreFoundation -framework Cocoa")
endif()

target_include_directories(vmpk PUBLIC
    $<$<BOOL:${XCB_FOUND}>:${XCB_INCLUDE_DIRS}>
)

target_compile_definitions ( vmpk PUBLIC
    VERSION=${PROJECT_VERSION}
    RAWKBD_SUPPORT
    PALETTE_SUPPORT
    $<$<BOOL:${ENABLE_DBUS}>:ENABLE_DBUS>
)

if (DEFINED PROJECT_WC_REVISION)
    target_compile_definitions ( vmpk PRIVATE
        REVISION=${PROJECT_WC_REVISION} )
endif()

target_compile_definitions(vmpk PRIVATE
    $<$<BOOL:${EMBED_TRANSLATIONS}>:TRANSLATIONS_EMBEDDED>
)

install (TARGETS vmpk
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    BUNDLE DESTINATION ~/Applications
)

=== debian/changelog ===
vmpk (0.8.6-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 0.8.6
  * d/copyright: Remove obsolete blkey.svg entry
  * Update d/source/lintian-overrides

  [ Sebastian Ramacher ]
  * debian/control: Bump libdrumstick to 2.5

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 06 Jan 2022 13:07:52 +0100

vmpk (0.8.5-1) unstable; urgency=medium

  * New upstream version 0.8.5
  * Refresh d/copyright years and entries
  * Remove obsolete d/dirs

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 06 Nov 2021 22:20:11 +0100

vmpk (0.8.4-1) unstable; urgency=medium

  [ Olivier Humbert ]
  * Update copyright (http->https + remove 1 empty line)

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1
  * d/watch: Use https protocol

  [ Dennis Braun ]
  * New upstream version 0.8.4
  * d/control:
    + Build with libdrumstick 2.0.0
    + Add me as uploader
    + Bump dh-compat to 13
    + Bump S-V to 4.6.0
    + Set RRR: no
    + Update homepage
    + Add libdrumstick-rt-backends to vmpk Depends
  * d/copyright:
    + Update source
    + Update d/copyright year
    + Add entry for net.sourceforge.VMPK.appdata.xml
  * Update d/docs
  * Add d/source/lintian-overrides
  * Add d/upstream/metadata
  * Update d/watch version

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 11 Sep 2021 21:32:04 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: sound
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: Ross Gammon <rosco2@ubuntu.com>
-Build-Depends: debhelper-compat (= 12),
+Uploaders: Ross Gammon <rosco2@ubuntu.com>,
+ Dennis Braun <d_braun@kabelmail.de>
+Build-Depends: debhelper-compat (= 13),
  cmake,
  pkg-config,
  xsltproc,
@@ -16,15 +17,19 @@
  qttools5-dev-tools,
  qttools5-dev,
  libqt5x11extras5-dev,
- libdrumstick-dev (>= 1.1.3)
-Standards-Version: 4.4.0
-Homepage: http://vmpk.sourceforge.net/
+ libdrumstick-dev (>= 2.5)
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
+Homepage: https://vmpk.sourceforge.io/
 Vcs-Browser: https://salsa.debian.org/multimedia-team/vmpk
 Vcs-Git: https://salsa.debian.org/multimedia-team/vmpk.git
 
 Package: vmpk
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ libdrumstick-rt-backends (>= 2.5)
 Recommends: qjackctl, qsynth
 Description: Virtual MIDI Piano Keyboard
  Virtual MIDI Piano Keyboard is a MIDI events generator and

## vmpk 0.8.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Virtual MIDI Piano Keyboard
-# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
+# Copyright (C) 2008-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")
 
 project( VMPK
-    VERSION 0.8.6
+    VERSION 0.8.7
     LANGUAGES CXX
     DESCRIPTION "Virtual MIDI Piano Keyboard"
     HOMEPAGE_URL "https://vmpk.sourceforge.io/"
@@ -28,7 +28,12 @@
 if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
     set(DBUS_INIT ON)
 endif()
+set(FILTER_INIT OFF)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
+    set(FILTER_INIT ON)
+endif()
 option(ENABLE_DBUS "Enable VMPK DBus interface" ${DBUS_INIT})
+option(ENABLE_NATIVE_FILTER "Use a QAbstractNativeEventFilter to process raw keyboard events" ${FILTER_INIT})
 option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)
 option(BUILD_DOCS "Build man page" ON)
 option(USE_QT "Choose which Qt major version (5 or 6) to prefer. By default uses whatever is found")
@@ -52,7 +57,7 @@
 #endif()
 
 # CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
-# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2021/03
+# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2022/04
 if(MSVC)
     string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
 endif()
@@ -80,7 +85,7 @@
     find_package(Qt6 6.2 COMPONENTS Gui Widgets Network LinguistTools REQUIRED)
 endif()
 
-find_package(Drumstick 2.5 COMPONENTS RT Widgets REQUIRED)
+find_package(Drumstick 2.6 COMPONENTS RT Widgets REQUIRED)
 
 message (STATUS "VMPK v${PROJECT_VERSION}
      install prefix: ${CMAKE_INSTALL_PREFIX}
@@ -88,6 +93,7 @@
      Operating System: ${CMAKE_SYSTEM_NAME}
      System Processor: ${CMAKE_SYSTEM_PROCESSOR}
      D-Bus support: ${ENABLE_DBUS}
+     Native Event Filter: ${ENABLE_NATIVE_FILTER}
      Qt${QT_VERSION_MAJOR} Version: ${QT_VERSION}
      Drumstick Version: ${Drumstick_VERSION}"
 )
@@ -97,19 +103,22 @@
 endif ()
 
 if (UNIX AND NOT APPLE)
-    if (QT_VERSION VERSION_LESS 6.0.0)
-        find_package(Qt5X11Extras REQUIRED)
+    if (ENABLE_NATIVE_FILTER)
+        if (QT_VERSION VERSION_LESS 6.0.0)
+            find_package(Qt5X11Extras REQUIRED)
+        endif()
+        find_package(PkgConfig REQUIRED)
+        if(PKG_CONFIG_FOUND)
+            message(STATUS "Program pkg-config v${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
+        else()
+            message(FATAL_ERROR "Program pkg-config not found")
+        endif()
+        pkg_check_modules(XCB REQUIRED xcb)
+        if(XCB_FOUND)
+            message(STATUS "Found XCB development libs v${XCB_VERSION}")
+        endif()
     endif()
-    find_package(PkgConfig REQUIRED)
-    if(PKG_CONFIG_FOUND)
-        message(STATUS "Program pkg-config v${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
-    else()
-        message(FATAL_ERROR "Program pkg-config not found")
-    endif()
-    pkg_check_modules(XCB REQUIRED xcb)
-    if(XCB_FOUND)
-        message(STATUS "Found XCB development libs v${XCB_VERSION}")
-    endif()
+    
     include(GNUInstallDirs)
 endif()
 
@@ -155,7 +164,7 @@
         COMMAND cp -r dbus vmpk-${PROJECT_VERSION}
         COMMAND cp translations/vmpk_{cs,de,es,fr,gl,ru,sr,sv}.ts vmpk-${PROJECT_VERSION}/translations/
         COMMAND cp translations/CMakeLists.txt vmpk-${PROJECT_VERSION}/translations/
-        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README.md TODO *.nsi *.nsi.in net.sourceforge.VMPK.desktop net.sourceforge.VMPK.appdata.xml vmpk.pro *.pri vmpk.spec.in qt.conf vmpk-${PROJECT_VERSION}
+        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README.md TODO *.nsi *.nsi.in net.sourceforge.VMPK.desktop net.sourceforge.VMPK.metainfo.xml vmpk.pro *.pri vmpk.spec.in qt.conf vmpk-${PROJECT_VERSION}
         COMMAND tar -cj --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.bz2 vmpk-${PROJECT_VERSION}
         COMMAND tar -cz --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.gz vmpk-${PROJECT_VERSION}
         COMMAND zip -qr vmpk-${PROJECT_VERSION}.zip vmpk-${PROJECT_VERSION} -x '.[a-z]*'
@@ -199,7 +208,7 @@
     install (FILES net.sourceforge.VMPK.desktop
              DESTINATION ${CMAKE_INSTALL_DATADIR}/applications )
 
-    install (FILES net.sourceforge.VMPK.appdata.xml
+    install (FILES net.sourceforge.VMPK.metainfo.xml
              DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo )
 
      # uninstall custom target

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Virtual MIDI Piano Keyboard
-# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
+# Copyright (C) 2008-2022 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -69,15 +69,12 @@
     keyboardmap.h
     kmapdialog.cpp
     kmapdialog.h
-    maceventhelper.h
     main.cpp
     mididefs.h
     midisetup.cpp
     midisetup.h
     preferences.cpp
     preferences.h
-    nativefilter.cpp
-    nativefilter.h
     riff.cpp
     riff.h
     riffimportdlg.cpp
@@ -93,6 +90,19 @@
     ${QT_RES}
 )
 
+if (ENABLE_NATIVE_FILTER)
+    list(APPEND vmpk_SRCS
+        nativefilter.cpp
+        nativefilter.h
+    )
+    if (APPLE)
+        list(APPEND vmpk_SRCS
+            maceventhelper.mm
+            maceventhelper.h
+        )
+    endif()
+endif()
+
 if(WIN32)
     include(CheckCXXSourceCompiles)
     check_cxx_source_compiles("#include <Windows.h>
@@ -105,7 +115,6 @@
 endif()
 
 if(ENABLE_DBUS)
-    add_definitions(-DENABLE_DBUS)
     if (QT_VERSION VERSION_LESS 5.15.0)
         qt5_add_dbus_adaptor( vmpk_SRCS
                               net.sourceforge.vmpk.xml
@@ -138,7 +147,7 @@
     set (MACOSX_BUNDLE_ICON_FILE "vmpk.icns" )
     set (MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.vmpk" )
     set (MACOSX_BUNDLE_BUNDLE_NAME "vmpk" )
-    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2021 Pedro López-Cabanillas and others")
+    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2022 Pedro López-Cabanillas and others")
     set (vmpk_RSC
         ../data/vmpk.icns
         ../data/help.html
@@ -158,7 +167,6 @@
 endif()
 
 add_executable (vmpk MACOSX_BUNDLE WIN32
-    $<$<PLATFORM_ID:Darwin>:maceventhelper.mm>
     $<$<PLATFORM_ID:Windows>:${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc>
     ${vmpk_SRCS}
     ${vmpk_RSC}
@@ -196,6 +204,7 @@
     RAWKBD_SUPPORT
     PALETTE_SUPPORT
     $<$<BOOL:${ENABLE_DBUS}>:ENABLE_DBUS>
+    $<$<BOOL:${ENABLE_NATIVE_FILTER}>:ENABLE_NATIVE_FILTER>
 )
 
 if (DEFINED PROJECT_WC_REVISION)

=== debian/changelog ===
vmpk (0.8.7-1) unstable; urgency=medium

  * New upstream version 0.8.7
  * Update d/copyright years
  * Update metainfo file

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 04 May 2022 21:05:31 +0200
